Index: trunk/i18n/uk.ts
===================================================================
--- trunk/i18n/uk.ts	(revision 39)
+++ trunk/i18n/uk.ts	(revision 42)
@@ -16,54 +16,55 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="156"/>
+        <location filename="../src/tspmodel.cpp" line="147"/>
         <source>Unexpected end of file.</source>
         <translation>Неочікуваний кінець файлу.</translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="158"/>
+        <location filename="../src/tspmodel.cpp" line="149"/>
         <source>Corrupt data read. File possibly corrupted.</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../src/tspmodel.cpp" line="160"/>
+        <translation>Прочитано ушкоджені дані.
+Можливо, файл пошкоджено.</translation>
+    </message>
+    <message>
+        <location filename="../src/tspmodel.cpp" line="151"/>
         <source>Unknown error.</source>
         <translation>Невідома помилка.</translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="161"/>
-        <location filename="../src/tspmodel.cpp" line="169"/>
-        <location filename="../src/tspmodel.cpp" line="184"/>
-        <location filename="../src/tspmodel.cpp" line="200"/>
-        <location filename="../src/tspmodel.cpp" line="213"/>
+        <location filename="../src/tspmodel.cpp" line="152"/>
+        <location filename="../src/tspmodel.cpp" line="160"/>
+        <location filename="../src/tspmodel.cpp" line="175"/>
+        <location filename="../src/tspmodel.cpp" line="191"/>
+        <location filename="../src/tspmodel.cpp" line="204"/>
+        <location filename="../src/tspmodel.cpp" line="234"/>
         <location filename="../src/tspmodel.cpp" line="243"/>
-        <location filename="../src/tspmodel.cpp" line="252"/>
         <source>Task Load</source>
-        <translation>Завантаження завдання</translation>
-    </message>
-    <message>
-        <location filename="../src/tspmodel.cpp" line="161"/>
-        <location filename="../src/tspmodel.cpp" line="184"/>
-        <location filename="../src/tspmodel.cpp" line="200"/>
-        <location filename="../src/tspmodel.cpp" line="213"/>
+        <translation>Завантаження умови</translation>
+    </message>
+    <message>
+        <location filename="../src/tspmodel.cpp" line="152"/>
+        <location filename="../src/tspmodel.cpp" line="175"/>
+        <location filename="../src/tspmodel.cpp" line="191"/>
+        <location filename="../src/tspmodel.cpp" line="204"/>
+        <location filename="../src/tspmodel.cpp" line="234"/>
         <location filename="../src/tspmodel.cpp" line="243"/>
-        <location filename="../src/tspmodel.cpp" line="252"/>
         <source>Unable to load task:</source>
-        <translation>Неможливо завантажити завдання:</translation>
-    </message>
-    <message>
-        <location filename="../src/tspmodel.cpp" line="169"/>
+        <translation>Неможливо завантажити умову:</translation>
+    </message>
+    <message>
+        <location filename="../src/tspmodel.cpp" line="160"/>
         <source>Unable to open task file.
 Error: %1</source>
-        <translation>Неможливо відкрити файл завдання.
+        <translation>Неможливо відкрити файл з умовою.
 Помилка: %1</translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="184"/>
+        <location filename="../src/tspmodel.cpp" line="175"/>
         <source>Unknown file format or file is corrupted.</source>
         <translation>Невідомий формат файлу або файл пошкоджено.</translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="200"/>
-        <location filename="../src/tspmodel.cpp" line="243"/>
+        <location filename="../src/tspmodel.cpp" line="191"/>
+        <location filename="../src/tspmodel.cpp" line="234"/>
         <source>File version is newer than application supports.
 Please, try to update application.</source>
@@ -72,41 +73,72 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="213"/>
-        <location filename="../src/tspmodel.cpp" line="252"/>
+        <location filename="../src/tspmodel.cpp" line="204"/>
+        <location filename="../src/tspmodel.cpp" line="243"/>
         <source>Unexpected data read.
 File is possibly corrupted.</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../src/tspmodel.cpp" line="282"/>
-        <location filename="../src/tspmodel.cpp" line="288"/>
-        <location filename="../src/tspmodel.cpp" line="295"/>
-        <location filename="../src/tspmodel.cpp" line="302"/>
-        <location filename="../src/tspmodel.cpp" line="309"/>
-        <location filename="../src/tspmodel.cpp" line="316"/>
-        <location filename="../src/tspmodel.cpp" line="323"/>
-        <location filename="../src/tspmodel.cpp" line="333"/>
+        <translation>Прочитано неочікувані дані.
+Можливо, файл пошкоджено.</translation>
+    </message>
+    <message>
+        <location filename="../src/tspmodel.cpp" line="273"/>
+        <location filename="../src/tspmodel.cpp" line="279"/>
+        <location filename="../src/tspmodel.cpp" line="286"/>
+        <location filename="../src/tspmodel.cpp" line="293"/>
+        <location filename="../src/tspmodel.cpp" line="300"/>
+        <location filename="../src/tspmodel.cpp" line="307"/>
+        <location filename="../src/tspmodel.cpp" line="314"/>
+        <location filename="../src/tspmodel.cpp" line="324"/>
         <source>Task Save</source>
-        <translation>Збереження завдання</translation>
-    </message>
-    <message>
-        <location filename="../src/tspmodel.cpp" line="282"/>
+        <translation>Збереження умови</translation>
+    </message>
+    <message>
+        <location filename="../src/tspmodel.cpp" line="273"/>
         <source>Unable to create task file.
 Error: %1
 Maybe, file is read-only?</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../src/tspmodel.cpp" line="288"/>
-        <location filename="../src/tspmodel.cpp" line="295"/>
-        <location filename="../src/tspmodel.cpp" line="302"/>
-        <location filename="../src/tspmodel.cpp" line="309"/>
-        <location filename="../src/tspmodel.cpp" line="316"/>
-        <location filename="../src/tspmodel.cpp" line="323"/>
-        <location filename="../src/tspmodel.cpp" line="333"/>
+        <translation>Неможливо створити файл з умовою.
+Помилка: %1
+Можливо, файл тільки для читання?</translation>
+    </message>
+    <message>
+        <location filename="../src/tspmodel.cpp" line="279"/>
+        <location filename="../src/tspmodel.cpp" line="286"/>
+        <location filename="../src/tspmodel.cpp" line="293"/>
+        <location filename="../src/tspmodel.cpp" line="300"/>
+        <location filename="../src/tspmodel.cpp" line="307"/>
+        <location filename="../src/tspmodel.cpp" line="314"/>
+        <location filename="../src/tspmodel.cpp" line="324"/>
         <source>Unable to save task.
 Error: %1</source>
-        <translation>Неможливо зберегти завдання.
+        <translation>Неможливо зберегти умову.
 Помилка: %1</translation>
+    </message>
+</context>
+<context>
+    <name>CTSPSolver</name>
+    <message>
+        <location filename="../src/tspsolver.cpp" line="137"/>
+        <source>%v of %m parts found</source>
+        <translation>Знайдено %v з %m переходів</translation>
+    </message>
+    <message>
+        <location filename="../src/tspsolver.cpp" line="141"/>
+        <source>Calculating optimal route...</source>
+        <translation>Обчислення оптимального шляху...</translation>
+    </message>
+    <message>
+        <location filename="../src/tspsolver.cpp" line="142"/>
+        <source>Solution Progress</source>
+        <translation>Поступ розв&apos;зку</translation>
+    </message>
+    <message>
+        <location filename="../src/tspsolver.cpp" line="210"/>
+        <source>Solution Result</source>
+        <translation>Результат розв&apos;язку</translation>
+    </message>
+    <message>
+        <location filename="../src/tspsolver.cpp" line="210"/>
+        <source>This task has no solution.</source>
+        <translation>У цієї задачі немає розв&apos;язку.</translation>
     </message>
 </context>
@@ -114,186 +146,198 @@
     <name>MainWindow</name>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="90"/>
-        <location filename="../ui/mainwindow.ui" line="69"/>
+        <location filename="../ui/mainwindow.ce.ui" line="87"/>
+        <location filename="../ui/mainwindow.ui" line="75"/>
         <source>Number of variant</source>
         <translation>Номер варіанту</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="113"/>
-        <location filename="../ui/mainwindow.ui" line="92"/>
+        <location filename="../ui/mainwindow.ce.ui" line="110"/>
+        <location filename="../ui/mainwindow.ui" line="98"/>
         <source>Number of cities</source>
         <translation>Кількість міст, що проходить комівояжер</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="291"/>
-        <location filename="../ui/mainwindow.ui" line="272"/>
+        <location filename="../ui/mainwindow.ce.ui" line="271"/>
+        <location filename="../ui/mainwindow.ui" line="259"/>
         <source>Select language</source>
         <translation>Вибір мови</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="294"/>
-        <location filename="../ui/mainwindow.ui" line="275"/>
+        <location filename="../ui/mainwindow.ce.ui" line="274"/>
+        <location filename="../ui/mainwindow.ui" line="262"/>
         <source>Select application language</source>
         <translation>Обрати мову додатку</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="332"/>
+        <location filename="../ui/mainwindow.ui" line="322"/>
         <source>P&amp;rint Setup...</source>
         <translation>&amp;Налагодження друку...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="335"/>
+        <location filename="../ui/mainwindow.ui" line="325"/>
         <source>Setup printing</source>
         <translation>Налагодити друк</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="347"/>
+        <location filename="../ui/mainwindow.ui" line="337"/>
         <source>&amp;Print...</source>
         <translation>&amp;Друк...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="350"/>
+        <location filename="../ui/mainwindow.ui" line="340"/>
         <source>Print solution results</source>
         <translation>Роздрукувати результат розв&apos;язку</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="353"/>
+        <location filename="../ui/mainwindow.ui" line="343"/>
         <source>Ctrl+P</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ui" line="573"/>
+        <location filename="../ui/mainwindow.ce.ui" line="356"/>
+        <location filename="../ui/mainwindow.ui" line="379"/>
+        <source>&amp;Solution...</source>
+        <translation>&amp;Розв&apos;язок...</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ui" line="559"/>
         <source>Save</source>
         <translation>Зберегти</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="531"/>
-        <location filename="../ui/mainwindow.ui" line="544"/>
+        <location filename="../ui/mainwindow.ce.ui" line="514"/>
+        <location filename="../ui/mainwindow.ui" line="530"/>
         <source>Detect language automatically</source>
         <translation>Визначати мову автоматично</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="534"/>
-        <location filename="../ui/mainwindow.ui" line="547"/>
+        <location filename="../ui/mainwindow.ce.ui" line="517"/>
+        <location filename="../ui/mainwindow.ui" line="533"/>
         <source>Detect language automatically based on regional settings</source>
         <translation>Визначати мову автоматично, використовуючи регіональні стандарти</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="517"/>
-        <location filename="../ui/mainwindow.ui" line="530"/>
+        <location filename="../ui/mainwindow.ce.ui" line="500"/>
+        <location filename="../ui/mainwindow.ui" line="516"/>
         <source>Ctrl+S</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="403"/>
-        <location filename="../ui/mainwindow.ui" line="416"/>
+        <location filename="../ui/mainwindow.ce.ui" line="386"/>
+        <location filename="../ui/mainwindow.ui" line="406"/>
         <source>Ctrl+N</source>
         <translation></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="56"/>
-        <location filename="../ui/mainwindow.ui" line="35"/>
+        <location filename="../ui/mainwindow.ce.ui" line="53"/>
+        <location filename="../ui/mainwindow.ui" line="41"/>
         <source>Task</source>
-        <translation>Завдання</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="77"/>
-        <location filename="../ui/mainwindow.ui" line="56"/>
+        <translation>Умова</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="74"/>
+        <location filename="../ui/mainwindow.ui" line="62"/>
         <source>&amp;Variant:</source>
         <translation>&amp;Варіант:</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="100"/>
-        <location filename="../ui/mainwindow.ui" line="79"/>
+        <location filename="../ui/mainwindow.ce.ui" line="97"/>
+        <location filename="../ui/mainwindow.ui" line="85"/>
         <source>&amp;Cities:</source>
         <translation>&amp;Міст:</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="144"/>
-        <location filename="../ui/mainwindow.ui" line="123"/>
+        <location filename="../ui/mainwindow.ce.ui" line="141"/>
+        <location filename="../ui/mainwindow.ui" line="129"/>
         <source>Cost of travel from city to city</source>
         <translation>Вартість переїзду з міста у місто</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="172"/>
-        <location filename="../ui/mainwindow.ui" line="151"/>
+        <location filename="../ui/mainwindow.ce.ui" line="169"/>
+        <location filename="../ui/mainwindow.ui" line="157"/>
         <source>Fill table with random numbers</source>
         <translation>Заповнити таблицю випадковими значеннями</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="175"/>
-        <location filename="../ui/mainwindow.ui" line="154"/>
+        <location filename="../ui/mainwindow.ce.ui" line="172"/>
+        <location filename="../ui/mainwindow.ui" line="160"/>
         <source>Random</source>
         <translation>Випадково</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="189"/>
-        <location filename="../ui/mainwindow.ui" line="168"/>
+        <location filename="../ui/mainwindow.ce.ui" line="186"/>
+        <location filename="../ui/mainwindow.ui" line="174"/>
         <source>Solve current task</source>
         <translation>Розв&apos;язати поточну задачу</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="192"/>
-        <location filename="../ui/mainwindow.ui" line="171"/>
+        <location filename="../ui/mainwindow.ce.ui" line="189"/>
+        <location filename="../ui/mainwindow.ui" line="177"/>
         <source>Solve</source>
         <translation>Розв&apos;язати</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="206"/>
-        <location filename="../ui/mainwindow.ui" line="185"/>
+        <location filename="../ui/mainwindow.ce.ui" line="203"/>
+        <location filename="../ui/mainwindow.ui" line="191"/>
         <source>Solution</source>
         <translation>Розв&apos;язок</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="223"/>
-        <location filename="../ui/mainwindow.ui" line="202"/>
+        <location filename="../ui/mainwindow.ce.ui" line="212"/>
+        <location filename="../ui/mainwindow.ui" line="200"/>
         <source>Solution steps</source>
         <translation>Хід розв&apos;язку</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="233"/>
-        <location filename="../ui/mainwindow.ui" line="212"/>
-        <source>Solution graph</source>
-        <translation>Граф розв&apos;язку</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="259"/>
-        <location filename="../ui/mainwindow.ui" line="240"/>
+        <location filename="../ui/mainwindow.ce.ui" line="242"/>
+        <location filename="../ui/mainwindow.ui" line="230"/>
         <source>&amp;File</source>
         <translation>&amp;Файл</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="266"/>
-        <location filename="../ui/mainwindow.ui" line="244"/>
+        <location filename="../ui/mainwindow.ce.ui" line="249"/>
+        <location filename="../ui/mainwindow.ui" line="234"/>
         <source>Save &amp;As...</source>
         <translation>Зберегти &amp;як...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="348"/>
-        <location filename="../ui/mainwindow.ui" line="361"/>
+        <location filename="../ui/mainwindow.ce.ui" line="277"/>
+        <location filename="../ui/mainwindow.ui" line="265"/>
+        <source>&amp;Language</source>
+        <comment>Please, append &quot; / Language&quot; when translating this string.</comment>
+        <translation>Мова / &amp;Language</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="328"/>
+        <location filename="../ui/mainwindow.ui" line="351"/>
         <source>Solution S&amp;teps</source>
         <translation>&amp;Хід розв&apos;язку</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="362"/>
-        <location filename="../ui/mainwindow.ui" line="375"/>
+        <location filename="../ui/mainwindow.ce.ui" line="342"/>
+        <location filename="../ui/mainwindow.ui" line="365"/>
         <source>Solution &amp;Graph</source>
         <translation>&amp;Граф розв&apos;язку</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="466"/>
-        <location filename="../ui/mainwindow.ui" line="479"/>
+        <location filename="../ui/mainwindow.ce.ui" line="359"/>
+        <source>Solution...</source>
+        <translation>Розв&apos;язок...</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="449"/>
+        <location filename="../ui/mainwindow.ui" line="469"/>
         <source>Context &amp;Help</source>
         <translation>&amp;Контекстна допомога</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="557"/>
-        <location filename="../ui/mainwindow.ui" line="570"/>
+        <location filename="../ui/mainwindow.ce.ui" line="540"/>
+        <location filename="../ui/mainwindow.ui" line="556"/>
         <source>&amp;Save</source>
         <translation>&amp;Зберегти</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="287"/>
-        <location filename="../ui/mainwindow.ui" line="268"/>
+        <location filename="../ui/mainwindow.ce.ui" line="267"/>
+        <location filename="../ui/mainwindow.ui" line="255"/>
         <source>&amp;Settings</source>
         <translation>&amp;Налагодження</translation>
